/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

static int exdebug = 0;

#include "ypp.h"

#define TABSIZ 2000

char *symbol[TABSIZ], *Symbol[TABSIZ], *Lymbol[TABSIZ];
int type[TABSIZ];
Rule *R[TABSIZ];
Decl *D[TABSIZ];
Exte *E[TABSIZ];

FILE *fd_treeh, *fd_treec [fd_treec_max], *fd_tokens, *fd_types, *fd_output;

int tok = 257;

int zzlineno = -1;

main()
{
	int i;
	char file [20];

	check_begin ();

	fd_treeh  = fopen ("treeaut.h", "w");

	for (i = 0; i < fd_treec_max; i++) {
		sprintf (file, "treeaut%d.c", i);
		fd_treec [i]  = fopen (file, "w");
		fprintf (fd_treec [i], "#include \"extern.h\"\n\n");
	}

	fd_tokens = fopen ("typesaut.h", "w");
	fd_types  = fopen ("typesaut.def", "w");
	fd_output = fopen ("outaut.def", "w");


	for (i = 0; i < TABSIZ; i++) {
		type[i] = UNDEF;
		symbol[i] = Symbol[i] = "";
		Lymbol[i] = (char*) 0;
		R[i] = (Rule*) 0;
		D[i] = (Decl*) 0;
		E[i] = (Exte*) 0;
	}
	type[tok] = TERM;
	symbol[tok] = "Error";
	Symbol[tok] = "error";
	tok++;

	yyparse ();

	dump_tokens ();
	dump_types ();

	check_end ();
	
	exit (0);
}

static check_begin ()
{
	U_check_begin (1);
}

static check_end ()
{
	int i;

	if (tok > TABSIZ)
		fatal ("tok > TABSIZ");

	U_check_end ();
}

dump_tokens ()
{
	int i;

	for (i = 0; i < tok; i++)
		if (type[i] != UNDEF) {
			if (type[i] == NONTERM && is_notdecsym (i) && is_notusedef (i))
				continue;
			fprintf (fd_tokens, "#define %-25s %4d\n", Symbol[i], i);
		}
	fprintf (fd_tokens, "#define %-25s %4d\n", "LAST_TOKEN", tok);
}

char *to_Symbol(nonterm)
char *nonterm;
{
	char *n, *N, *Nonterm;
	int i;

	Nonterm = (char*) U_malloc (2 * strlen (nonterm) + 1);
	if (islower (*nonterm))
		*Nonterm = toupper (*nonterm);
	else if (isupper (*nonterm))
		*Nonterm = *nonterm;
	else
		fprintf (stderr, "ERROR: creat_Nonterm: unexpected character\n");

	for (n = nonterm + 1, N = Nonterm + 1; *n != '\0'; n++)
		if (islower (*n))
			*N++ = toupper (*n);
		else {
			*N++ = '_';
			*N++ = *n;
		}
	*N = '\0';

	return Nonterm;
}

char *get_lit_symbol (str)
char *str;
{
	int i, ltok = (int) *(str+1);

	if (exdebug)
		printf ("get_lit_symbol: ltok = %d\n", ltok);

	if (type[ltok] == 0) {
		sprintf (serr, "get_lit_symbol: must define literal %s with '%%token ...'\n" , str);
		fatal (serr);
	}
	else if (type[ltok] != LIT) {
		sprintf (serr, "get_lit_symbol: [%s]", str);
		fatal (serr);
	}
	else {
		return symbol[ltok];
	}

}

char *to_symbol (str)
char *str;
{
	char *p, *t, *newstr = (char*) U_malloc (strlen (str) + 1);

	if (*str == '\'') {
		return get_lit_symbol (str);
	}

	for (p = str; *p != '\0'; p++)
		if (islower (*p))
			return str;

	p = str;
	t = newstr;
	*t++ = *p++;
	for ( ;*p != '\0'; p++, t++)
		if (*p == '_') {
			p++;
			*t = *p;
		}
		else
			*t = tolower (*p);

	return newstr;
}

dump_types ()
{
	int i, nodes;
	char *stype, *name, *sname;
	int fun = 0;
	
	for (i = 0; i < tok; i++) {

		switch (type[i]) {
		case TERM: stype = "TERM"; break;
		case NONTERM: stype = "NONTERM"; break;
		case LIT: stype = "LIT"; break;
		default: stype = "UNDEF"; break;
		}

		if (is_notdecsym (i))
			sname = "def";
		else
			sname = symbol[i];

		if (D[i] == (Decl*) 0)
			nodes = 0;
		else
			nodes = D[i]->ndecl;

/*
		fprintf (fd_types, "{%s, \"%s\", \"%s\", sizeof (struct S_%s), %d},\n"
		        , stype, symbol[i], Symbol[i], sname, nodes);
*/
		fprintf (fd_types, "{%s, \"%s\", sizeof (struct S_%s), %d},\n"
		        , stype, Symbol[i], sname, nodes);
	}
}

odon () {}
table_show1 () {}
